#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>
#include "functions.h"
#include <avr/interrupt.h>
#include <avr/eeprom.h>

//global vars
	uint16_t EEMEM eeKM;
	uint16_t EEMEM eeM;
	uint16_t EEMEM eeDKM;
	uint16_t EEMEM eeMaxTemp;
	uint16_t EEMEM eeWarnTemp;
	uint16_t EEMEM eeRadUmfang;
	uint16_t EEMEM eeIgnitions;
		uint16_t iWarnTemp;
    	uint16_t iKM;
		uint16_t icm;
		uint16_t iM;
		uint16_t iMaxTemp;
		uint16_t iDKM;
		uint16_t iRadUmfang;
		uint16_t iIgnitions;
	uint16_t iRPM=0;
	volatile uint16_t iV=0;
	uint16_t iTemp;
	volatile uint16_t speedvar=0;
	volatile uint16_t tachoold=0;
	volatile uint16_t tachonew=0;
	uint16_t dzmold=0;
	uint16_t dzmnew=0;
	uint16_t dzmvar=0;
	uint16_t tachosignale;
	char scenario;
	char dzmflag;
	char lcdon=0;

ISR(TIMER1_OVF_vect) 
{
	
}

ISR(TIMER0_OVF_vect) 
{	
	dzmflag=1;
	dzmnew=TCNT1/10;
	if(dzmold!=0)
	{
		if(dzmnew>dzmold)	dzmvar=dzmnew-dzmold;
		else dzmvar=6553-dzmold+dzmnew;
		iRPM=9830/(dzmvar/100); 
	}
	dzmold=dzmnew;
}



ISR(INT0_vect)
{
	tachosignale++;
	tachonew=TCNT1/10;
	if(tachoold!=0)
	{
		if(tachonew>tachoold)	speedvar=tachonew-tachoold;
		else speedvar=6553-tachoold+tachonew;
		iV=(iRadUmfang*59)/(speedvar); 
	}
	tachoold=tachonew;
}


ISR ( ANA_COMP_vect )
{
 	eeprom_write_word(&eeKM, iKM);
	eeprom_write_word(&eeM, iM);
	eeprom_write_word(&eeDKM, iDKM);
	eeprom_write_word(&eeMaxTemp, iMaxTemp);
	lcd_bel(0);
	lcdon=0;
	lcd_clrscr();
	_delay_ms(5);
	lcd_puts("datasave");	
	lcd_bel(1);
	_delay_ms(2000);
	lcd_clrscr();
}


int main(void)
{

_delay_ms(1000);

//Portrichtungsregister setzen
	DDRA |= (1 << DDA1) | (1 << DDA2); //a0 data eingang, a1 cs ausg, a2 clk ausg 
	PORTA &= (1<<PA0); //internen pull up aktivieren
	DDRC |= (1<<PC7); //lcd bel pin
	DDRB  |= (1<<DDB0);// | (1<<DDB2) | (1<<DDB3);  //b0 als eingang fr dzm, b2,3 fr ac
	PORTB |= (1<<PB0) | (1<<PB2);    //internen pull up aktivieren
//	DDRD  |= (1<<DDD2);
	PORTD |= (1<<PD2);
	

//deactivate interrupts
	cli();



//load var from eeprom
    iKM = eeprom_read_word(&eeKM);
    iM = eeprom_read_word(&eeM);
	iMaxTemp = eeprom_read_word(&eeMaxTemp);
	iDKM= eeprom_read_word(&eeDKM);
	iRadUmfang=eeprom_read_word(&eeRadUmfang);
	iIgnitions=eeprom_read_word(&eeIgnitions);
	iWarnTemp=eeprom_read_word(&eeWarnTemp);

//check if var is bogus and set 0 then
	if(iKM==0xFFFF){iKM=0;eeprom_write_word(&eeKM,0);}
	if(iM==0xFFFF){iM=0;eeprom_write_word(&eeM,0);}
	if(iMaxTemp==0xFFFF){iMaxTemp=0;eeprom_write_word(&eeMaxTemp,0);}
	if(iDKM==0xFFFF){iDKM=0;eeprom_write_word(&eeDKM,0);}
	if(iRadUmfang==0xFFFF){iRadUmfang=50;eeprom_write_word(&eeRadUmfang,50);}
	if(iIgnitions==0xFFFF){iIgnitions=1;eeprom_write_word(&eeIgnitions,1);}
	if(iWarnTemp==0xFFFF){iWarnTemp=1500;eeprom_write_word(&eeWarnTemp,1500);}





//displaybeleuchtung an
	lcd_bel(1);lcdon=1;
//zeit frs display aufzuwachen
	_delay_ms(50);
//lcd init
	_delay_ms(50);
	lcd_init(LCD_DISP_ON);
	_delay_ms(50);
	lcd_clrscr();
//welcome screen
	_delay_ms(50);		
	lcd_puts("   VesCom 1.0   ");
	_delay_ms(1000);
	lcd_gotoxy(0, 1);
	_delay_ms(5);
	lcd_puts("    by  dare");
	_delay_ms(3000);
	lcd_clrscr();	


//start timer for systemtime ( 16384 hz)
   TCCR1B = (1<< CS12);
//set interrupt for dzm timer
	TIMSK |= (1<<TOIE0);
//timer0 vorladen
	TCNT0=246;

//start timer for dzm
	TCCR0 |= (1<<CS02) | (1<<CS01);  



//steigende/fallende? flanke lst interrupt aus
	MCUCR |= (1<<ISC01);
//enable interrupt on int0
	GIMSK |= (1<<INT0);


//startscenario
	scenario=1;

//set ac for power loose interrupt
//	ACSR = (1 << ACIE) | (1 << ACIS1); 


//activate interrupts
	sei();




for(;;)
	{

	dzmflag=0;
//put temp in iTemp
	fReadTemp(&iTemp); 
//temp warning function
	if(iTemp>=iWarnTemp) 
	{
		if(lcdon==1)
		{
			lcd_bel(0); 
			lcdon=0;
		}else 
		{
			lcd_bel(1);
			lcdon=1;
		}
	} else lcd_bel(1);

	
//maxtemp
	if(iTemp>iMaxTemp){eeprom_write_word(&eeMaxTemp,iTemp);iMaxTemp=iTemp;}

//werte ausgeben
	fOutput(scenario,iV,iRPM,iTemp,iMaxTemp,iKM,iM,iDKM); 

	for(uint16_t i=0;i<40000;i++)
		{
			if (fdebounce(&PINA, PA4)==1) {if(scenario>5)scenario=1; else scenario++; lcd_clrscr();}
			if (fdebounce(&PINA, PA3)==1) 
			{ 	
				eeprom_write_word(&eeKM, iKM);
				eeprom_write_word(&eeM, iM);
				eeprom_write_word(&eeDKM, iDKM);
				eeprom_write_word(&eeMaxTemp, iMaxTemp);
				menu(&eeDKM,&eeMaxTemp,&eeIgnitions,&eeWarnTemp,&eeRadUmfang);
			}
		}
	
	icm+=tachosignale*iRadUmfang;
	if(tachosignale==0)iV=0;
	tachosignale=0;
	while(icm>=100){iM++;icm-=100;}
	if(iM>=1000){iKM++; iDKM++; iM-=1000;}
	if(dzmflag==0)iRPM=0;

	}
return 0;
}

