#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"
#include <stdlib.h>
#include <string.h>
#include <avr/eeprom.h>
#include "functions.h"
#include <avr/wdt.h>
#include <avr/interrupt.h>

void menu(uint16_t *eeDKM,uint16_t *eeMaxTemp,uint16_t *eeIgnitions,uint16_t *eeWarnTemp,uint16_t *eeRadUmfang)
{
	lcd_bel(1);
	_delay_ms(5);
	lcd_clrscr();

	char menu=0;
	uint8_t state=1;
	uint16_t radumfang= eeprom_read_word(eeRadUmfang);
	uint16_t warntemp=eeprom_read_word(eeWarnTemp);
	while(menu<1)
	{

			switch(state)
			{
				case 1:
						_delay_ms(5);
						lcd_gotoxy(0, 0);
						_delay_ms(5);
						lcd_puts("Menu:");
						_delay_ms(5);
						lcd_gotoxy(0, 1);
						_delay_ms(5);
						lcd_puts(" ->, X   ");
						while(state<2)
						{
							if (fdebounce(&PINA, PA4)==1) state=2;
							if (fdebounce(&PINA, PA3)==1) 
							{
								cli();wdt_enable (WDTO_15MS);while (1); //atmega abschiessen
							}
						}
				break;

				case 2:
					_delay_ms(5);
					lcd_gotoxy(0,1);
					_delay_ms(5);
					lcd_puts("Tag-Km=0");
					while(state<3)
					{
						if (fdebounce(&PINA, PA3)==1) eeprom_write_word(eeDKM, 0);
						if (fdebounce(&PINA, PA4)==1) state=3;
					}
				break;

				case 3:
					_delay_ms(5);
					lcd_gotoxy(0,1);
					_delay_ms(5);
					lcd_puts("MxTemp=0");
					while(state<4)
					{
						if (fdebounce(&PINA, PA3)==1) eeprom_write_word(eeMaxTemp, 0);
						if (fdebounce(&PINA, PA4)==1) state=4;
					}
				break;

				case 4:
					while(state<5)
					{
					int ign=eeprom_read_word(eeIgnitions);
					_delay_ms(5);
					lcd_gotoxy(0,1);
					_delay_ms(5);

						if(ign==1)lcd_puts("Znd/U: 1"); 
							else lcd_puts("Znd/U: 2");
						if (fdebounce(&PINA, PA3)==1) 
						{
							if(ign==1) eeprom_write_word(eeIgnitions, 2);
							else eeprom_write_word(eeIgnitions, 1);
						}
						if (fdebounce(&PINA, PA4)==1) state=5;
						_delay_ms(10);
					}
				break;

				case 5:
		
					while(state<6)
					{					
						_delay_ms(5);
						lcd_gotoxy(0,1);
						_delay_ms(5);
						char out1[3];
						itoa(radumfang,out1,10);
						char out2[8];
						strcpy(out2,"Umfa:");
						if(radumfang<100) strcat(out2," ");
						if(radumfang<10) strcat(out2," ");
						strcat(out2,out1);
						lcd_puts(out2);
						if (fdebounce(&PINA, PA3)==1) 
						{
							if(radumfang<200) radumfang++;
							else radumfang=1;
						}
									
						if (fdebounce(&PINA, PA4)==1) 
						{
							state=6;
							eeprom_write_word(eeRadUmfang,radumfang);							
						}
						_delay_ms(10);
					}
				break;

				case 6:
					
					while(state<7)
					{
						_delay_ms(5);
						lcd_gotoxy(0,1);
						_delay_ms(5);
						char out1[4];
						itoa(warntemp,out1,10);
						char out2[9];
						strcpy(out2,"WTp:");
						if(warntemp<1000) strcat(out2," ");
						if(warntemp<100) strcat(out2, " ");
						if(warntemp<10) strcat(out2, " ");
						
						
						strcat(out2,out1);
						
						lcd_puts(out2);
						
						if (fdebounce(&PINA, PA3)==1) 
						{
							if(warntemp<1200) warntemp+=5;
							else warntemp=1;
						}
									
						if (fdebounce(&PINA, PA4)==1) 
						{
							eeprom_write_word(eeWarnTemp, warntemp);
							state=7;
						}
							
						_delay_ms(10);
					}
				break;

				default:
					state=1;
				break;
			}


	}
}




uint8_t fdebounce(volatile uint8_t *port, uint8_t pin)
{
    if ( ! (*port & (1 << pin)) )
    {
	    _delay_ms(50); 
        _delay_ms(50); 
        if ( *port & (1 << pin) )
        {
            _delay_ms(50);
            _delay_ms(50); 
            return 1;
        }
    }
    return 0;
}


void fOutput(char scenario,uint16_t iV,uint16_t iRpm,uint16_t iTemp,uint16_t iMaxTemp,uint16_t iKM,uint16_t iM, uint16_t iDKM)
{
	char sSpeed[8];
	char sRpm[8];
	char sTemp[8];
	char sMaxTemp[8];
	char sDKM[8];
	char sKM[8];

	uint8_t iStrLen;
	
//Speed

	iStrLen=0;
	char sV2[8];
	itoa(iV,sV2,10); //int to string
	iStrLen=5-strlen(sV2); //how many spaces to add?

	strcpy(sSpeed,"V:");
	while(iStrLen>0)
	{
		strcat(sSpeed," ");
		iStrLen=iStrLen-1;
	}
	strcat(sSpeed,sV2);
//	sSpeed[7]='\0';



//Rpm
	iStrLen=0;
	char sRPM2[8];
	itoa(iRpm,sRPM2,10); //int to string
	iStrLen=5-strlen(sRPM2); //how many spaces to add?
	
	strcpy(sRpm,"U:");
	while(iStrLen>0)
	{
		strcat(sRpm," ");
		iStrLen=iStrLen-1;
	}
	strcat(sRpm,sRPM2);

//Temp
	iStrLen=0;
	char sTemp2[8];
	itoa(iTemp,sTemp2,10); //int to string
	iStrLen=4-strlen(sTemp2); //how many spaces to add?
	strcpy(sTemp,"Tp:");

	while(iStrLen>0)
	{
		strcat(sTemp," ");
		iStrLen=iStrLen-1;
	}
	strcat(sTemp,sTemp2);


//MaxTemp
	iStrLen=0;
	char sMT2[8];
	itoa(iMaxTemp,sMT2,10); //int to string
	iStrLen=4-strlen(sMT2); //how many spaces to add?
	strcpy(sMaxTemp,"mT:");

	while(iStrLen>0)
	{
		strcat(sMaxTemp," ");
		iStrLen=iStrLen-1;
	}
	strcat(sMaxTemp,sMT2);


//Distance
	char sMeter[8];
	uint8_t iMeter=iM/100;
	itoa(iMeter,sMeter,10);
	char sKilom[8];
	itoa(iKM,sKilom,10);
	iStrLen=5-strlen(sKilom); //how many spaces to add?
	strcpy(sKM,"");
	while(iStrLen>0)
	{
		strcat(sKM," ");
		iStrLen=iStrLen-1;
	}
	strcat(sKM,sKilom);
	strcat(sKM,".");
	strcat(sKM,sMeter);

//Tageskilometer
	iStrLen=0;
	char sDKM2[8];
	itoa(iDKM,sDKM2,10); //int to string
	iStrLen=5-strlen(sDKM2); //how many spaces to add?
	strcpy(sDKM,"D:");
	while(iStrLen>0)
	{
		strcat(sDKM," ");
		iStrLen=iStrLen-1;
	}
	strcat(sDKM,sDKM2);
	




	char ol[7];
	char or[7];
	char ul[7];
	char ur[7];

	switch(scenario)
	{

		case 1:
			strcpy(ol,sSpeed);
			strcpy(or,sRpm);
			strcpy(ul,sKM);
			strcpy(ur,sTemp);
		break;

		case 2:
			strcpy(ol,sSpeed);
			strcpy(or,sRpm);
			strcpy(ul,sMaxTemp);
			strcpy(ur,sTemp);
		break;

		case 3:
			strcpy(ol,sSpeed);
			strcpy(or,sRpm);
			strcpy(ul,sKM);
			strcpy(ur,sDKM);
		break;

		case 4:
			strcpy(ol,sSpeed);
			strcpy(or,"       ");
			strcpy(ul,sRpm);
			strcpy(ur,"       ");
		break;

		default:
			strcpy(ol,sSpeed);
			strcpy(or,sRpm);
			strcpy(ul,sKM);
			strcpy(ur,sTemp);
		break;
	}

	lcd_gotoxy(0,0);
	_delay_ms(5);
	lcd_puts(ol);
	_delay_ms(5);
	lcd_gotoxy(7,0);
	_delay_ms(5);
	lcd_puts("  ");
	_delay_ms(5);
	lcd_gotoxy(9,0);
	_delay_ms(5);
	lcd_puts(or);
	_delay_ms(5);
	lcd_gotoxy(0,1);
	_delay_ms(5);
	lcd_puts(ul);
	lcd_gotoxy(7,1);
	_delay_ms(5);
	lcd_puts("  ");
	_delay_ms(5);
	_delay_ms(5);
	lcd_gotoxy(9,1);
	_delay_ms(5);
	lcd_puts(ur);

}


void lcd_bel(char opt)
{
	if(opt==0) 	PORTC &= ~(1<<PA7); //beleuchtung aus
	else PORTC |= (1<<PA7); //beleuchtung an
}

void fReadTemp(uint16_t *iTemp)
{
	PORTA |= (1<<PA1); //cs high for measure
	PORTA &= ~(1<<PA2); //clk low but dontcare
	_delay_ms(1);
	PORTA &= ~(1<<PA1); //cs low for data
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=512; else *iTemp=0;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+256;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+128;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+64;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+32;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+16;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+8;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+4;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+2;
	_delay_ms(1);
	PORTA |= (1<<PA2); //clk high 
	_delay_ms(1);
	PORTA &= ~(1<<PA2); //clk low
	_delay_ms(1);
	if ( PINA & (1<<PINA0) ) *iTemp=*iTemp+1;

	PORTA &= ~(1<<PA2); //clk low
	PORTA |= (1<<PA1); //cs high for measure
	PORTA &= ~(1<<PA2); //clk low but dontcare	
}



